"""
=================================================
@Project -> File    ：my_way_of_python -> 装饰器
@IDE                ：PyCharm
@Author             ：Mr.chao
@Date               ：2021/3/19 下午5:09
@用途               ：
@email              ：chz970511@163.com
==================================================
"""

"""
    设计一个装饰器，它可以作用于任何函数上，打印函数执行时间
"""

import time


# def metric(fn):
#     start_time = time.time()
#     end_time = time.time()
#     print('耗时：{:.4f}s'.format(end_time - start_time))
#     return fn

def decorate(fun):
    """
    打印函数被调用的时间及调用次数
    """

    def wrapper(*args, **kwargs):
        start_time = time.time()
        fun()
        end_time = time.time()
        print('耗时：{:.4f}s'.format(end_time - start_time))
        return action
    return wrapper


@decorate
def action():
    row = 1
    while row < 10:
        col = 1
        while col < row + 1:
            print('{} × {} = {:<4}'.format(row, col, col * row), end=' ')
            col += 1
        row += 1
        print('')


if __name__ == '__main__':
    action()
